/* exported init */
const Clutter = imports.gi.Clutter;

const ExtensionUtils = imports.misc.extensionUtils;
const Main = imports.ui.main;

class MoveNotificationsExtension {
    enable() {
        const updatePanel = Main.panel._updatePanel;
        this._updatePanelOrig = updatePanel;

        Main.panel._updatePanel = () => {
            updatePanel.call(Main.panel);

            Main.messageTray.bannerAlignment = this._getAlignment();
        };

        this._settings = ExtensionUtils.getSettings();
        this._changedId = this._settings.connect('changed::position',
            () => Main.panel._updatePanel());
        Main.panel._updatePanel();
    }

    disable() {
        this._settings.disconnect(this._changedId);
        this._settings = null;

        Main.panel._updatePanel = this._updatePanelOrig;
        delete this._updatePanelOrig;

        Main.panel._updatePanel();
    }

    _getAlignment() {
        switch (this._settings.get_string('position')) {
        case 'top-left':
            return Clutter.ActorAlign.START;
        case 'top-right':
            return Clutter.ActorAlign.END;
        case 'top-center':
        default:
            return Clutter.ActorAlign.CENTER;
        }
    }
}

function init() {
    return new MoveNotificationsExtension();
}
